### Draw from Priors...
#######################

#######################################
#######################################
SigmaFix_5d_Prior = function(m0.1,c0.1,M0,C0,nu1,lam1,nu2,lam2,nu3,lam3,nu4,lam4,nu5,lam5){
  aux = t(chol(Sigma)) 
  
  A = solve(aux)
  D = diag(1/diag(A))
  PHI = D%*%A
  
  
  
  phi21  = -PHI[2,1]
  phi31  = -PHI[3,1]
  phi32  = -PHI[3,2]
  phi41  = -PHI[4,1]
  phi42  = -PHI[4,2]
  phi43  = -PHI[4,3]
  phi51  = -PHI[5,1]
  phi52  = -PHI[5,2]
  phi53  = -PHI[5,3]
  phi54  = -PHI[5,4]
  
  
  par1  = (nu1)/2
  par2  = nu1*lam1 
  sig11  = 1/rgamma(1,par1,par2/2)
  
  par1  = (nu2)/2
  par2  = nu2*lam2 
  sig2.1  = 1/rgamma(1,par1,par2/2)
  
  par1  = (nu3)/2
  par2  = nu3*lam3 
  sig3.12  = 1/rgamma(1,par1,par2/2)
  
  par1  = (nu4)/2
  par2  = nu4*lam4 
  sig4.123  = 1/rgamma(1,par1,par2/2)
  
  par1  = (nu5)/2
  par2  = nu5*lam5
  sig5.1234  = 1/rgamma(1,par1,par2/2)

 
  C1 = c0.1
  m1 = m0.1
  
  aux21 = m1 + sqrt(C1)*rnorm(1)
  if(aux21<0) phi21 = aux21
  
  V1 = C0[1:2,1:2]
  M1 = M0[1:2]
	
  out = M1 + t(chol(V1))%*%rnorm(2)
  phi31 = out[1]
  phi32 = out[2]
 
  V1 = C0[3:5,3:5]
  M1 = M0[3:5]
	
  out = M1 + t(chol(V1))%*%rnorm(3)
  phi41 = out[1]
  phi42 = out[2]
  phi43 = out[3]
 
  V1 = C0[6:9,6:9]
  M1 = M0[6:9]
	
  out = M1 + t(chol(V1))%*%rnorm(4)
  phi51 = out[1]
  phi52 = out[2]
  phi53 = out[3] 
  phi54 = out[4] 
  
  
  
  PHI[2,1] = -phi21
  PHI[3,1] = -phi31
  PHI[3,2] = -phi32
  PHI[4,1] = -phi41
  PHI[4,2] = -phi42
  PHI[4,3] = -phi43
  PHI[5,1] = -phi51
  PHI[5,2] = -phi52
  PHI[5,3] = -phi53
  PHI[5,4] = -phi54
  
  
  D[1,1] = sqrt(sig11)
  D[2,2] = sqrt(sig2.1)
  D[3,3] = sqrt(sig3.12)
  D[4,4] = sqrt(sig4.123)
  D[5,5] = sqrt(sig5.1234)
  
  A = solve(D)%*%PHI 
  L = solve(A)
  SigmaOUT = L%*%t(L)
    
  return(SigmaOUT)  	
	}


#######################################
#######################################
sampleCOEF_MU_3d_Prior = function(m0,C0){

	V1 = C0
	M1 = m0
	
	out = M1 + t(chol(V1))%*%rnorm(2)
	return(out)
	}



SIGsPrior = array(0,c(5,5,niter))

MUcoefsPrior = matrix(0,2,niter)

PastorMeanPrior = matrix(0,niter,50)
PastorVarPrior  = matrix(0,niter,50)


for (i in 1:niter){ 


aux = sampleCOEF_MU_3d_Prior(m0_MUcoef,C0_MUcoef)
if(aux[2]<0.9999&aux[2]>0){
	a = aux[1]
	b = aux[2]
	}


Sigma = SigmaFix_5d_Prior(m0.1,C0.1,M0_Phi,C0_Phi,nu1,lam1,nu2,lam2,nu3,lam3,nu4,lam4,nu5,lam5)

MUcoefsPrior[1,i] = a
MUcoefsPrior[2,i] = b
 
SIGsPrior[,,i] = Sigma 

PastorMeanPrior[i,1] = ComputePastorMEAN(a,b,Sigma,1,C0,m0)
PastorVarPrior[i,1]  = ComputePastorVAR(a,b,Sigma,1,C0,m0)


for(j in 2:50){
	PastorMeanPrior[i,j] = ComputePastorMEAN(a,b,Sigma,j,C0,m0)
	PastorVarPrior[i,j]  = ComputePastorVAR(a,b,Sigma,j,C0,m0)
	}
	
	

print(i)

}

