################################################################
## Prior for mu_0                                              #
################################################################
m0    = 0.05
C0    = 0.1^2

################################################################
## Priors for mu coefficients                                  #
################################################################
b     =   0.7
a     =   mean(R)*(1-b) 
m0_MUcoef  = c(a,b)
C0_MUcoef = matrix(c(0.05^2,0,0,0.1333^2),2,2)

################################################################
## Priors for X's AR coefficients                              #
################################################################
if(1){
ax1    = 0.305
bx1    = 0.935

ax2    = -0.0138
bx2    = -0.01694

ax3    = 0.1912
bx3    = 0.6458
}


m0_X1coef  = c(ax1,0.5)
C0_X1coef = diag(1,2)

m0_X2coef  = c(ax2,0.5)
C0_X2coef = diag(1,2)

m0_X3coef  = c(ax3,0.5)
C0_X3coef = diag(1,2)

eps = matrix(0,(n-1),5)

################################################################
## Priors for Sigma                                            #
################################################################

Sigma = matrix(0,5,5)
Sigma[1,1] = var(R)
Sigma[2,2] = 0.1*Sigma[1,1]
Sigma[3,3] = var(x[,1])
Sigma[4,4] = var(x[,2])
Sigma[5,5] = var(x[,3])


if(strong) Sigma[1,2] = (sqrt(Sigma[1,1])*sqrt(Sigma[2,2]))*-0.85
if(!strong) Sigma[1,2] = (sqrt(Sigma[1,1])*sqrt(Sigma[2,2]))*-0.5
Sigma[2,1] = Sigma[1,2]

cSig = t(chol(Sigma))
A = solve(cSig)
S = diag(1/diag((A)))	
Phi = S%*%A

nu1 = 5
nu2 = 5
nu3 = 5
nu4 = 5
nu5 = 5

lam1 = S[1,1]^2
lam2 = S[2,2]^2
lam3 = S[3,3]^2 
lam4 = S[4,4]^2
lam5 = S[5,5]^2

m0.1 = -Phi[2,1]
C0.1 = 0.065^2


### X's in or out: Zero out C0_Phi!!!
#####################################
M0_Phi = rep(0,9)

## No predictors setting:
C0_Phi = diag(c(0.000000001,0.000000001,0.000000001,0.000000001,0.000000001,0.000000001,0.000000001,0.000000001,0.000000001),9)

 
################################################################
## End of Prior for Sigma                                      #
################################################################

###########################
### Setting MCMC variables#
###########################
niter = 5000
MM    = array(0,c(6,1,n-1))
WW    = array(0,c(6,6,n-1))
m     = rep(0,n)
C     = rep(0,n)
MUs   = matrix(0,n,niter)
MW    = computeMW_PS3d(m0,C0,x0)
M     = MW$M
W     = MW$W
mC    = computemC_PS3d(M,W,1)
m[1]  = mC$m
C[1]  = mC$C

SIGs = array(0,c(5,5,niter))

X1coefs = matrix(0,2,niter) 
X2coefs = matrix(0,2,niter) 
X3coefs = matrix(0,2,niter) 

MUcoefs = matrix(0,2,niter)
MUs = matrix(0,n,niter)
Rfuture = matrix(0,niter,hoz)
MUsF    = matrix(0,niter,hoz)

gridW = 100
w = seq(0,1,length=gridW)
Uw = matrix(0,gridW,hoz)
rf = 0.02
Arisk  = 8
allocation=0

PastorMean = matrix(0,niter,hoz)
PastorVar  = matrix(0,niter,hoz)
PastorComp1 = matrix(0,niter,hoz) 
PastorComp2 = matrix(0,niter,hoz)
PastorComp3 = matrix(0,niter,hoz)
PastorComp4 = matrix(0,niter,hoz)

################################################################
## Drawing from Priors                                         #
################################################################
source("DrawPriors.R")


################################################################
## RUN MCMC                                                    #
################################################################

for (i in 1:niter){ 

## Forward Filter
#################
for(t in 2:n){
  MW   = computeMW_PS3d(m[t-1],C[t-1],x[t-1,])
  M    = MW$M
  W    = MW$W
  mC   = computemC_PS3d(M,W,t)
  m[t] = mC$m
  C[t] = mC$C
  MM[,,t-1] = M
  WW[,,t-1] = W
}

# Backward sampling
###################  
 
  MUs[n,i] = rnorm(1,m[n],C[n])
  for(t in (n-1):1){
	  MUs[t,i] = sampleMU_PS3d(MM[,,t],WW[,,t],MUs[t+1,i],t)
	}

mu  = MUs[,i]




aux = sampleCOEF_MU_3d(mu,Sigma,m0_MUcoef,C0_MUcoef)
if(aux[2]<0.9999&aux[2]>0){
	a = aux[1]
	b = aux[2]
	}

aux = sampleCOEF_X1_3d(mu,Sigma,m0_X1coef,C0_X1coef)
if(aux[2]<0.9999){
	ax1 = aux[1]
	bx1 = aux[2]
	}

aux = sampleCOEF_X2_3d(mu,Sigma,m0_X2coef,C0_X2coef)
if(aux[2]<0.9999){
	ax2 = aux[1]
	bx2 = aux[2]
	}

aux = sampleCOEF_X3_3d(mu,Sigma,m0_X3coef,C0_X3coef)
if(aux[2]<0.9999){
	ax3 = aux[1]
	bx3 = aux[2]
	}


eps[,1] = r[2:n] - mu[1:(n-1)]
eps[,2] = mu[2:n] - a - b*mu[1:(n-1)]
eps[,3] = x[2:n,1] - ax1 - bx1*x[1:(n-1),1]
eps[,4] = x[2:n,2] - ax2 - bx2*x[1:(n-1),2]
eps[,5] = x[2:n,3] - ax3 - bx3*x[1:(n-1),3]


Sigma = SigmaFix_5d(eps,m0.1,C0.1,M0_Phi,C0_Phi,nu1,lam1,nu2,lam2,nu3,lam3,nu4,lam4,nu5,lam5,Sigma)


MUs[,i] = mu

MUcoefs[1,i] = a
MUcoefs[2,i] = b
 
X1coefs[1,i] = ax1
X1coefs[2,i] = bx1

X2coefs[1,i] = ax2
X2coefs[2,i] = bx2

X3coefs[1,i] = ax3
X3coefs[2,i] = bx3

SIGs[,,i] = Sigma 


epsf = t(chol(Sigma[1:2,1:2]))%*%rnorm(2)

Rfuture[i,1] = mu[n]+epsf[1]
MUsF[i,1] = mu[n]
muf = a+b*mu[n] + epsf[2]

PastorMean[i,1] = ComputePastorMEAN(a,b,Sigma,1,C[n],m[n])
PastorVar[i,1]  = ComputePastorVAR(a,b,Sigma,1,C[n],m[n])

aux = ComputePastorComp(a,b,Sigma,1,C[n],m[n])
PastorComp1[i,1] = aux[1]
PastorComp2[i,1] = aux[2]
PastorComp3[i,1] = aux[3]
PastorComp4[i,1] = aux[4]
 


for(j in 2:hoz){
	epsf = t(chol(Sigma[1:2,1:2]))%*%rnorm(2)
	Rfuture[i,j] = muf + epsf[1]
	muf = a + b*muf + epsf[2]
	MUsF[i,j] = muf
	PastorMean[i,j] = ComputePastorMEAN(a,b,Sigma,j,C[n],m[n])
	PastorVar[i,j]  = ComputePastorVAR(a,b,Sigma,j,C[n],m[n])
	
	
    aux = ComputePastorComp(a,b,Sigma,j,C[n],m[n])
    PastorComp1[i,j] = aux[1]
    PastorComp2[i,j] = aux[2]
    PastorComp3[i,j] = aux[3]
    PastorComp4[i,j] = aux[4]

}
	

print(i)


}


### END of MCMC
############
# POSTERIORS
############

burn = 2000
graphics.off()

lixo = matrix(0,niter-burn,hoz)
for(i in 1:(niter-burn)) lixo[i,] = cumsum(Rfuture[burn+i,])
LongRunRet =  (apply(lixo,2,mean)/(1:hoz))
LongRunVol =  sqrt(apply(lixo,2,var)/(1:hoz))

LongRunPastor = apply(PastorMean[burn:niter,],2,mean) + apply(PastorVar[burn:niter,],2,var)
LongRunPastor = sqrt(LongRunPastor/(1:hoz))

LongRunPastorPrior = apply(PastorMeanPrior,2,mean) + apply(PastorVarPrior,2,var)
LongRunPastorPrior = sqrt(LongRunPastorPrior/(1:hoz))



quartz()
par(mfrow=c(2,3))
hist(sqrt(SIGsPrior[1,1,100:niter]),prob=T,nclass=50,main="Sig11",xlab="",xlim=c(0,0.5))
hist(sqrt(SIGsPrior[2,2,100:niter]),prob=T,nclass=50,main="Sig22",xlab="",xlim=c(0,0.2))
hist(SIGsPrior[1,2,100:niter]/sqrt(SIGsPrior[1,1,100:niter]*SIGsPrior[2,2,100:niter]),prob=T,nclass=50,main="corr12",xlab="",xlim=c(-1,0))

hist(sqrt(SIGs[1,1,burn:niter]),prob=T,nclass=50,main="Sig11",xlab="",xlim=c(0,0.5))
hist(sqrt(SIGs[2,2,burn:niter]),prob=T,nclass=50,main="Sig22",xlab="",xlim=c(0,0.2))
hist(SIGs[1,2,burn:niter]/sqrt(SIGs[1,1,burn:niter]*SIGs[2,2,burn:niter]),prob=T,nclass=50,main="corr12",xlab="",xlim=c(-1,0))










