################################################################
## Prior for mu_0                                              #
################################################################
m0    = 0.05
C0    = 0.1^2

################################################################
## Priors for mu coefficients                                  #
################################################################
b     =   0.8
a     =   mean(R)*(1-b) 
m0_MUcoef  = c(a,b)
C0_MUcoef = matrix(c(0.05^2,0,0,0.2^2),2,2)



################################################################
## Priors for X's AR coefficients                              #
################################################################
if(1){

bx1    = 0.95
ax1    = mean(x[,1])*bx1

bx2    = 0.8
ax2    = mean(x[,2])*bx2

bx3    = 0.5
ax3    = mean(x[,3])*bx3
}


m0_X1coef  = c(ax1,0.5)
C0_X1coef = diag(1,2)

m0_X2coef  = c(ax2,0.5)
C0_X2coef = diag(1,2)

m0_X3coef  = c(ax3,0.5)
C0_X3coef = diag(1,2)

eps = matrix(0,(n-1),5)

################################################################
## Priors for Sigma                                            #
################################################################
sig1.0 = sqrt(var(R))
sig2.0 = sqrt(0.1*sig1.0^2)
rho.0  = -0.8
kappa=0.5; 
rhobar=rho.0


Sigma = matrix(0,5,5)
Sigma[1,1] = sig1.0^2
Sigma[2,2] = sig2.0^2
Sigma[3,3] = var(x[,1])
Sigma[4,4] = var(x[,2])
Sigma[5,5] = var(x[,3])

Sigma[1,2] = (sqrt(Sigma[1,1])*sqrt(Sigma[2,2]))*rho.0
Sigma[2,1] = Sigma[1,2]

cSig = t(chol(Sigma))
A = solve(cSig)
S = diag(1/diag((A)))	
Phi = S%*%A

nu1 = 15
nu2 = 10
nu3 = 5
nu4 = 5
nu5 = 5

lam1 = S[1,1]^2
lam2 = S[2,2]^2
lam3 = S[3,3]^2 
lam4 = S[4,4]^2
lam5 = S[5,5]^2

m0.1 = -Phi[2,1]
C0.1 = 0.05^2
C0.1 = 0.11^2
#C0.1 = 0.0000001^2
#m0.1 = 0
#C0.1 = 0.000000005^2

SigmaS = array(0,c(n,5,5))
for(t in 1:n) SigmaS[t,,] = Sigma

ng=40
#grid for theta1
l1 = log(S[1,1]/2)*2
u1 = log(S[1,1]*2)*2
ng1 = ng
g1 = l1 + (u1-l1)*(1:ng1)/ng1

#grid for theta2
l2 = log(S[2,2]/2)*2
u2 = log(S[2,2]*2)*2
ng2 = ng
g2 = l2 + (u2-l2)*(1:ng2)/ng2

#grid for theta3
Sigma[1,2] = (sqrt(Sigma[1,1])*sqrt(Sigma[2,2]))*0
Sigma[2,1] = Sigma[1,2]
cSig = t(chol(Sigma))
A = solve(cSig)
S = diag(1/diag((A)))	
Phi0 = S%*%A
Sigma[1,2] = (sqrt(Sigma[1,1])*sqrt(Sigma[2,2]))*-0.9
Sigma[2,1] = Sigma[1,2]
cSig = t(chol(Sigma))
A = solve(cSig)
S = diag(1/diag((A)))	
Phi1 = S%*%A


l3 = -Phi0[2,1] 
u3 = -Phi1[2,1]
ng3 = ng
g3 = l3 + (u3-l3)*(1:ng3)/ng3

gL = list(g1,g2,g3) #list of all three grids

# set priors and hyperparameters
#priors for starting values of the three thetas (states)
mo=c((l1+u1)/2,(l2+u2)/2,(l3+u3)/2)
Co=c((abs(u1-l1)/2)^2,(abs(u2-l2)/2)^2,(abs(u3-l3)/2)^2)

#AR parameters for three states: thetai_t = a[i] + b[i] thetai_{t-1} + s[i] Z, t=1,2,3
phi.0 = rho.0 *(sig2.0/sig1.0)
tau.0 = sig2.0 * sqrt(1-rho.0^2) 

Corn_b = c(0.95,0.95,0.95)

Corn_a = rep(0,3)

Corn_a[1] = log(sig1.0^2)*(1-Corn_b[1])
Corn_a[2] = log(tau.0^2)*(1-Corn_b[2])
Corn_a[3] = phi.0*(1-Corn_b[3])

Corn_s=rep(0,3)

Corn_s[1] = sqrt(((abs(u1-l1)/4)^2) * (1-Corn_b[1]^2))
Corn_s[2] = sqrt(((abs(u2-l2)/4)^2) * (1-Corn_b[2]^2))
Corn_s[3] = sqrt(((abs(u3-l3)/4)^2) * (1-Corn_b[3]^2))



#starting values for theta1, theta2, theta3
theta1 = rep(mo[1],n-1)
theta2 = rep(mo[2],n-1)
theta3 = rep(mo[3],n-1)
thetao = mo

dopri = F


### X's in or out: Zero out C0_Phi!!!
#####################################
M0_Phi = rep(0,9)
C0_Phi = diag(c(0.000000001,0.000000001,0.000000001,0.000000001,0.000000001,0.000000001,0.000000001,0.000000001,0.000000001),9)

 
################################################################
## End of Prior for Sigma                                      #
################################################################
 
### MCMC variables 
 
niter = 5000
burn = 2000
MM    = array(0,c(6,1,n-1))
WW    = array(0,c(6,6,n-1))
m     = rep(0,n)
C     = rep(0,n)
MUs   = matrix(0,n,niter)
MW    = computeMW_PS3d_TV(m0,C0,x0,SigmaS[2,,])
M     = MW$M
W     = MW$W
mC    = computemC_PS3d(M,W,1)
m[1]  = mC$m
C[1]  = mC$C

SIGs = array(0,c(5,5,niter))
SIGs   = matrix(0,3,n-1)
TTs    = matrix(0,3,n-1)
RHO    = rep(0,n-1)
RHO_prior    = rep(0,n-1)

draws = array(0,c(niter,3,n))

X1coefs = matrix(0,2,niter) 
X2coefs = matrix(0,2,niter) 
X3coefs = matrix(0,2,niter) 

MUcoefs = matrix(0,2,niter)

MUs = matrix(0,n,niter)

Rfuture = matrix(0,niter,50)

PastorMean = matrix(0,niter,50)
PastorVar  = matrix(0,niter,50)
PastorComp1 = matrix(0,niter,50) 
PastorComp2 = matrix(0,niter,50)
PastorComp3 = matrix(0,niter,50)
PastorComp4 = matrix(0,niter,50)



################################################################
## RUN MCMC                                                    #
################################################################

for (i in 1:niter){ 

## Forward Filter
#################
for(t in 2:n){
  MW   = computeMW_PS3d_TV(m[t-1],C[t-1],x[t-1,],SigmaS[t,,])
  M    = MW$M
  W    = MW$W
  mC   = computemC_PS3d(M,W,t)
  m[t] = mC$m
  C[t] = mC$C
  MM[,,t-1] = M
  WW[,,t-1] = W
}

# Backward sampling
###################  
 
  MUs[n,i] = rnorm(1,m[n],C[n])
  for(t in (n-1):1){
	  MUs[t,i] = sampleMU_PS3d(MM[,,t],WW[,,t],MUs[t+1,i],t)
	}

mu  = MUs[,i]




aux = sampleCOEF_MU_3d_TV(mu,SigmaS,m0_MUcoef,C0_MUcoef)
if(aux[2]<0.9999&aux[2]>0){
	a = aux[1]
	b = aux[2]
	}

aux = sampleCOEF_X1_3d(mu,Sigma,m0_X1coef,C0_X1coef)
if(aux[2]<0.9999){
	ax1 = aux[1]
	bx1 = aux[2]
	}

aux = sampleCOEF_X2_3d(mu,Sigma,m0_X2coef,C0_X2coef)
if(aux[2]<0.9999){
	ax2 = aux[1]
	bx2 = aux[2]
	}

aux = sampleCOEF_X3_3d(mu,Sigma,m0_X3coef,C0_X3coef)
if(aux[2]<0.9999){
	ax3 = aux[1]
	bx3 = aux[2]
	}


eps[,1] = r[2:n] - mu[1:(n-1)]
eps[,2] = mu[2:n] - a - b*mu[1:(n-1)]
eps[,3] = x[2:n,1] - ax1 - bx1*x[1:(n-1),1]
eps[,4] = x[2:n,2] - ax2 - bx2*x[1:(n-1),2]
eps[,5] = x[2:n,3] - ax3 - bx3*x[1:(n-1),3]



dat = matrix(0,(n-1),2)
dat[,1] = R[2:n]-mu[1:(n-1)]
dat[,2] = mu[2:n] - a - b*mu[1:(n-1)]


temp = rcorn(dat,gL,Corn_a,Corn_b,Corn_s,kappa,rhobar,mo,Co,theta1,theta2,theta3,thetao,dopr=0)
theta1=temp$theta1; theta2=temp$theta2; theta3=temp$theta3; thetao = temp$thetao

SigmaS[(2:n),1,1] = exp(theta1)
SigmaS[(2:n),2,2] = theta3^2 * SigmaS[(2:n),1,1] + exp(theta2)
SigmaS[(2:n),1,2] = theta3 * SigmaS[(2:n),1,1]
SigmaS[(2:n),2,1] = SigmaS[(2:n),1,2]

TTs[1,] = TTs[1,]+theta1
TTs[2,] = TTs[2,]+theta2
TTs[3,] = TTs[3,]+theta3


SIGs[1,]=SIGs[1,] + SigmaS[(2:n),1,1]
SIGs[2,]=SIGs[2,] + SigmaS[(2:n),2,2]
SIGs[3,]=SIGs[3,] + SigmaS[(2:n),1,2]

RHO = RHO + (SigmaS[(2:n),1,2]/sqrt(SigmaS[(2:n),1,1]*SigmaS[(2:n),2,2]))


draws[i,1,] = SigmaS[,1,1]
draws[i,2,] = SigmaS[,2,2]
draws[i,3,] = (SigmaS[,1,2]/sqrt(SigmaS[,1,1]*SigmaS[,2,2]))


MUs[,i] = mu

MUcoefs[1,i] = a
MUcoefs[2,i] = b
 
X1coefs[1,i] = ax1
X1coefs[2,i] = bx1

X2coefs[1,i] = ax2
X2coefs[2,i] = bx2

X3coefs[1,i] = ax3
X3coefs[2,i] = bx3


epsf = t(chol(SigmaS[n,1:2,1:2]))%*%rnorm(2)

Rfuture[i,1] = mu[n]+epsf[1]
muf = a+b*mu[n] + epsf[2]

PastorMean[i,1] = ComputePastorMEAN(a,b,SigmaS[n,,],1,C[n],m[n])
PastorVar[i,1]  = ComputePastorVAR(a,b,SigmaS[n,,],1,C[n],m[n])

aux = ComputePastorComp(a,b,SigmaS[n,,],1,C[n],m[n])
PastorComp1[i,1] = aux[1]
PastorComp2[i,1] = aux[2]
PastorComp3[i,1] = aux[3]
PastorComp4[i,1] = aux[4]
  
thetaf = c(theta1[n-1],theta2[n-1],theta3[n-1])
SigF = SigmaS[n,1:2,1:2]
epsf = t(chol(SigmaS[n,1:2,1:2]))%*%rnorm(2)
for(j in 2:50){
	
	Rfuture[i,j] = muf + epsf[1]
	muf = a + b*muf + epsf[2]
	
	thetaf = Corn_a + Corn_b*thetaf + Corn_s*rnorm(3)
	SigF[1,1]   = exp(thetaf[1])
	SigF[2,2]   = thetaf[3]^2 * SigF[1,1] + exp(thetaf[2])
    SigF[1,2]   = thetaf[3] * SigF[1,1]
	SigF[2,1]   = SigF[1,2]
	
	epsf = t(chol(SigF))%*%rnorm(2)
	
	PastorMean[i,j] = ComputePastorMEAN(a,b,SigmaS[n,,],j,C[n],m[n])
	PastorVar[i,j]  = ComputePastorVAR(a,b,SigmaS[n,,],j,C[n],m[n])
	
    aux = ComputePastorComp(a,b,SigmaS[n,,],j,C[n],m[n])
    PastorComp1[i,j] = aux[1]
    PastorComp2[i,j] = aux[2]
    PastorComp3[i,j] = aux[3]
    PastorComp4[i,j] = aux[4]
	
	}

print(i)


}


### END of MCMC

graphics.off()


############
# POSTERIORS
############




lixo = matrix(0,niter-burn,50)
for(i in 1:(niter-burn)) lixo[i,] = cumsum(Rfuture[burn+i,])
LongRunRet =  (apply(lixo,2,mean)/(1:50))
LongRunVol =  sqrt(apply(lixo,2,var)/(1:50))

LongRunPastor = apply(PastorMean[burn:niter,],2,mean) + apply(PastorVar[burn:niter,],2,var)
LongRunPastor = sqrt(LongRunPastor/(1:50))

